<template>
	<q-page>
		<div class="q-pa-md">
			<q-table
				title="User Management"
				:data="users"
				:columns="columns"
				row-key="name"
			>
				<template v-slot:body="props">
					<q-tr :props="props">
						<q-td key="name" :props="props">
							{{ props.row.USERNAME }}
						</q-td>
						<q-td key="privilege" :props="props">
							<q-btn
								color="white"
								text-color="black"
								label="Privilege"
								@click="
									userPriv({
										userId: props.row.USER_ID,
										userName: props.row.USERNAME,
										userPriv: bol,
									})
								"
							/>
						</q-td>
					</q-tr>
				</template>
			</q-table>
		</div>
		<user-priv />
	</q-page>
</template>

<script>
import { mapActions } from "vuex";
import { mapGetters } from "vuex";
export default {
	components: {
		"user-priv": require("./user-modals/UserPriv.vue").default,
	},
	data() {
		return {
			bol: true,
			columns: [
				{
					name: "name",
					required: true,
					label: "Username",
					align: "left",
					field: (row) => row.name,
					format: (val) => `${val}`,
					sortable: true,
				},
				{
					name: "privilege",
					label: "Privilege",
					align: "center",
					field: "privilege",
				},
			],

			users: [],
		};
	},
	methods: {
		getUserData() {
			this.$axios
				.get(
					this.host +
						"/src/php/actions/user.php?req=user-mng-fetch-all",
					{
						withCredentials: true,
					}
				)
				.then((response) => {
					this.users = response.data;
				});
		},
		// access() {},
		...mapActions({
			userPriv: "showcase/userPriv",
		}),
	},
	computed: {
		...mapGetters({
			umModify: "showcase/umModify",
			userLevel: "showcase/userLevel",
		}),
	},
	created() {
		this.getUserData();
		if (this.userLevel == "staff") {
			this.bol = JSON.parse(this.umModify);
		}
	},
};
</script>
